<?php
/*
  $Id: micropayment_hp_ipn.php,v 1.0.0.0 19/05/2008 14:14:28 Michael Cici Exp $

  Copyright (c) 2004 osCommerce
  Released under the GNU General Public License

  Als Vorlage einzelner Ablaeufe diente Edith Karnitsch's PayPal_IPN_v2.2-Contrib.

  Nutzung auf eigene Gefahr.
*/

  class micropayment_hp_ipn {
    var $code, $title, $description, $enabled, $identifier, $test;

// class constructor
    function micropayment_hp_ipn() {
      global $order, $currencies, $currency, $insert_id;


      $this->code         = 'micropayment_hp_ipn';
      $this->title        = MODULE_PAYMENT_MICROPAYMENT_HP_IPN_TEXT_TITLE;
      $this->description  = MODULE_PAYMENT_MICROPAYMENT_HP_IPN_TEXT_DESCRIPTION;
      $this->sort_order   = MODULE_PAYMENT_MICROPAYMENT_HP_IPN_SORT_ORDER;
      $this->enabled      = ((MODULE_PAYMENT_MICROPAYMENT_HP_IPN_STATUS == 'True') ? true : false);
      $this->email_footer = MODULE_PAYMENT_MICROPAYMENT_HP_IPN_TEXT_EMAIL_FOOTER;
      $this->identifier   = 'osCommerce Micropayment HP IPN v1.0';

      if ((int)MODULE_PAYMENT_MICROPAYMENT_HP_IPN_PREPARE_ORDER_STATUS_ID > 0) {
        $this->order_status = MODULE_PAYMENT_MICROPAYMENT_HP_IPN_PREPARE_ORDER_STATUS_ID;
      }

      if (is_object($order)) $this->update_status();

      $this->form_action_url = 'http://billing.micropayment.de/handypay/event/';

    }

// class methods
    function update_status() {
      global $order;

      if ( ($this->enabled == true) && ((int)MODULE_PAYMENT_MICROPAYMENT_HP_IPN_ZONE > 0) ) {
        $check_flag = false;
        $check_query = tep_db_query("select zone_id from " . TABLE_ZONES_TO_GEO_ZONES . " where geo_zone_id = '" . MODULE_PAYMENT_MICROPAYMENT_HP_IPN_ZONE . "' and zone_country_id = '" . $order->billing['country']['id'] . "' order by zone_id");
        while ($check = tep_db_fetch_array($check_query)) {
          if ($check['zone_id'] < 1) {
            $check_flag = true;
            break;
          } elseif ($check['zone_id'] == $order->billing['zone_id']) {
            $check_flag = true;
            break;
          }
        }

        if ($check_flag == false) {
          $this->enabled = false;
        }
      }
    }

    function javascript_validation() {
      return false;
    }

    function selection() {

      global $order, $currencies;
      
	if ($order->info['total'] >= MODULE_PAYMENT_MICROPAYMENT_HP_IPN_MIN_TOTAL && 
	    $order->info['total'] <= MODULE_PAYMENT_MICROPAYMENT_HP_IPN_MAX_TOTAL &&
	    ($order->info['total'] == '0.49' || $order->info['total'] == '0.99' || $order->info['total'] == '1.49' || $order->info['total'] == '1.99' || $order->info['total'] == '2.49' || $order->info['total'] == '2.99' || $order->info['total'] == '3.49' || $order->info['total'] == '3.99' || $order->info['total'] == '4.99') )  {

	      return array('id'     => $this->code,
	                   'module' => $this->title,
				 'fields' => array(array('title' => MODULE_PAYMENT_MICROPAYMENT_HP_IPN_TEXT_CHECKOUT_PAYMENT)));

      }

    }

    function pre_confirmation_check() {
      return false;
    }

    function confirmation() {
      global $cartID, $cart_MICROPAYMENT_HP_IPN_ID, $customer_id, $languages_id, $order, $order_total_modules;

     // if (tep_session_is_registered('cartID')) {
	 // PandA.nl: register_globals fix
     if (array_key_exists('cartID', $_SESSION)) {
        $insert_order = false;

        if (tep_session_is_registered('cart_MICROPAYMENT_HP_IPN_ID')) {
          $order_id = substr($cart_MICROPAYMENT_HP_IPN_ID, strpos($cart_MICROPAYMENT_HP_IPN_ID, '-')+1);

          $curr_check = tep_db_query("select currency from " . TABLE_ORDERS . " where orders_id = '" . (int)$order_id . "'");
          $curr = tep_db_fetch_array($curr_check);

           //if ( ($curr['currency'] != $order->info['currency']) || ($cartID != substr($cart_MICROPAYMENT_HP_IPN_ID, 0, strlen($cartID))) ) {
            //$check_query = tep_db_query('select orders_id from ' . TABLE_ORDERS_STATUS_HISTORY . ' where orders_id = "' . (int)$order_id . '" limit 1'); 
			$check_query = tep_db_query('select orders_id from ' . TABLE_ORDERS_STATUS_HISTORY . ' where orders_id = "' . (int)$order_id . '" limit 2');  //1.4

            $update_order = false;//1.4
			
			//if (tep_db_num_rows($check_query) < 1) {
              //tep_db_query('delete from ' . TABLE_ORDERS . ' where orders_id = "' . (int)$order_id . '"');
			if (tep_db_num_rows($check_query) == 1) { //1.4
			  $update_order = true; //1.4
              tep_db_query('delete from ' . TABLE_ORDERS_TOTAL . ' where orders_id = "' . (int)$order_id . '"');
              tep_db_query('delete from ' . TABLE_ORDERS_STATUS_HISTORY . ' where orders_id = "' . (int)$order_id . '"');
              tep_db_query('delete from ' . TABLE_ORDERS_PRODUCTS . ' where orders_id = "' . (int)$order_id . '"');
              tep_db_query('delete from ' . TABLE_ORDERS_PRODUCTS_ATTRIBUTES . ' where orders_id = "' . (int)$order_id . '"');
              tep_db_query('delete from ' . TABLE_ORDERS_PRODUCTS_DOWNLOAD . ' where orders_id = "' . (int)$order_id . '"');
            }

            $insert_order = true;
		  //}	
        } else {
          $insert_order = true;
        }

        if ($insert_order == true) {
          $order_totals = array();
          if (is_array($order_total_modules->modules)) {
            reset($order_total_modules->modules);
            while (list(, $value) = each($order_total_modules->modules)) {
              $class = substr($value, 0, strrpos($value, '.'));
              if ($GLOBALS[$class]->enabled) {
                for ($i=0, $n=sizeof($GLOBALS[$class]->output); $i<$n; $i++) {
                  if (tep_not_null($GLOBALS[$class]->output[$i]['title']) && tep_not_null($GLOBALS[$class]->output[$i]['text'])) {
                    $order_totals[] = array('code'       => $GLOBALS[$class]->code,
                                            'title'      => $GLOBALS[$class]->output[$i]['title'],
                                            'text'       => $GLOBALS[$class]->output[$i]['text'],
                                            'value'      => $GLOBALS[$class]->output[$i]['value'],
                                            'sort_order' => $GLOBALS[$class]->sort_order);
                  }
                }
              }
            }
          }

          $sql_data_array = array('customers_id'                => $customer_id,
                                  'customers_name'              => $order->customer['firstname'] . ' ' . $order->customer['lastname'],
                                  'customers_company'           => $order->customer['company'],
                                  'customers_street_address'    => $order->customer['street_address'],
                                  'customers_suburb'            => $order->customer['suburb'],
                                  'customers_city'              => $order->customer['city'],
                                  'customers_postcode'          => $order->customer['postcode'],
                                  'customers_state'             => $order->customer['state'],
                                  'customers_country'           => $order->customer['country']['title'],
                                  'customers_telephone'         => $order->customer['telephone'],
                                  'customers_email_address'     => $order->customer['email_address'],
                                  'customers_address_format_id' => $order->customer['format_id'],
                                  'delivery_name'               => $order->delivery['firstname'] . ' ' . $order->delivery['lastname'],
                                  'delivery_company'            => $order->delivery['company'],
                                  'delivery_street_address'     => $order->delivery['street_address'],
                                  'delivery_suburb'             => $order->delivery['suburb'],
                                  'delivery_city'               => $order->delivery['city'],
                                  'delivery_postcode'           => $order->delivery['postcode'],
                                  'delivery_state'              => $order->delivery['state'],
                                  'delivery_country'            => $order->delivery['country']['title'],
                                  'delivery_address_format_id'  => $order->delivery['format_id'],
                                  'billing_name'                => $order->billing['firstname'] . ' ' . $order->billing['lastname'],
                                  'billing_company'             => $order->billing['company'],
                                  'billing_street_address'      => $order->billing['street_address'],
                                  'billing_suburb'              => $order->billing['suburb'],
                                  'billing_city'                => $order->billing['city'],
                                  'billing_postcode'            => $order->billing['postcode'],
                                  'billing_state'               => $order->billing['state'],
                                  'billing_country'             => $order->billing['country']['title'],
                                  'billing_address_format_id'   => $order->billing['format_id'],
                                  'payment_method'              => $order->info['payment_method'],
                                  'cc_type'                     => $order->info['cc_type'],
                                  'cc_owner'                    => $order->info['cc_owner'],
                                  'cc_number'                   => $order->info['cc_number'],
                                  'cc_expires'                  => $order->info['cc_expires'],
                                  'date_purchased'              => 'now()',
                                  'orders_status'               => $order->info['order_status'],
                                  'currency'                    => $order->info['currency'],
                                  'currency_value'              => $order->info['currency_value']);

		  //+1.4
		  if ( $update_order ){  
		    tep_db_perform(TABLE_ORDERS, $sql_data_array, 'update', 'orders_id = "' . (int)$order_id . '"');
            $insert_id = (int)$order_id;
		  } else { 
		  //-1.4
          tep_db_perform(TABLE_ORDERS, $sql_data_array);

          $insert_id = tep_db_insert_id();
		  }//1.4

          for ($i=0, $n=sizeof($order_totals); $i<$n; $i++) {
            $sql_data_array = array('orders_id'  => $insert_id,
                                    'title'      => $order_totals[$i]['title'],
                                    'text'       => $order_totals[$i]['text'],
                                    'value'      => $order_totals[$i]['value'],
                                    'class'      => $order_totals[$i]['code'],
                                    'sort_order' => $order_totals[$i]['sort_order']);

            tep_db_perform(TABLE_ORDERS_TOTAL, $sql_data_array);
          }
		  //+1.4
		  $sql_data_array = array('orders_id'        => $insert_id, 
                                    'orders_status_id'   => $order->info['order_status'], 
                                    'date_added'         => 'now()', 
						 'customer_notified' => '0', 
                                    'comments'           => $order->info['comments']);
          tep_db_perform(TABLE_ORDERS_STATUS_HISTORY, $sql_data_array);
		  //-1.4

          for ($i=0, $n=sizeof($order->products); $i<$n; $i++) {
            $sql_data_array = array('orders_id'         => $insert_id,
                                    'products_id'       => tep_get_prid($order->products[$i]['id']),
                                    'products_model'    => $order->products[$i]['model'],
                                    'products_name'     => $order->products[$i]['name'],
                                    'products_price'    => $order->products[$i]['price'],
                                    'final_price'       => $order->products[$i]['final_price'],
                                    'products_tax'      => $order->products[$i]['tax'],
                                    'products_quantity' => $order->products[$i]['qty']);

            tep_db_perform(TABLE_ORDERS_PRODUCTS, $sql_data_array);

            $order_products_id = tep_db_insert_id();

            $attributes_exist = '0';
            if (isset($order->products[$i]['attributes'])) {
              $attributes_exist = '1';
              for ($j=0, $n2=sizeof($order->products[$i]['attributes']); $j<$n2; $j++) {
                if (DOWNLOAD_ENABLED == 'true') {
                  $attributes_query = "select popt.products_options_name, poval.products_options_values_name, pa.options_values_price, pa.price_prefix, pad.products_attributes_maxdays, pad.products_attributes_maxcount , pad.products_attributes_filename
                                       from " . TABLE_PRODUCTS_OPTIONS . " popt, " . TABLE_PRODUCTS_OPTIONS_VALUES . " poval, " . TABLE_PRODUCTS_ATTRIBUTES . " pa
                                       left join " . TABLE_PRODUCTS_ATTRIBUTES_DOWNLOAD . " pad
                                       on pa.products_attributes_id=pad.products_attributes_id
                                       where pa.products_id = '" . $order->products[$i]['id'] . "'
                                       and pa.options_id = '" . $order->products[$i]['attributes'][$j]['option_id'] . "'
                                       and pa.options_id = popt.products_options_id
                                       and pa.options_values_id = '" . $order->products[$i]['attributes'][$j]['value_id'] . "'
                                       and pa.options_values_id = poval.products_options_values_id
                                       and popt.language_id = '" . $languages_id . "'
                                       and poval.language_id = '" . $languages_id . "'";
                  $attributes = tep_db_query($attributes_query);
                } else {
                  $attributes = tep_db_query("select popt.products_options_name, poval.products_options_values_name, pa.options_values_price, pa.price_prefix from " . TABLE_PRODUCTS_OPTIONS . " popt, " . TABLE_PRODUCTS_OPTIONS_VALUES . " poval, " . TABLE_PRODUCTS_ATTRIBUTES . " pa where pa.products_id = '" . $order->products[$i]['id'] . "' and pa.options_id = '" . $order->products[$i]['attributes'][$j]['option_id'] . "' and pa.options_id = popt.products_options_id and pa.options_values_id = '" . $order->products[$i]['attributes'][$j]['value_id'] . "' and pa.options_values_id = poval.products_options_values_id and popt.language_id = '" . $languages_id . "' and poval.language_id = '" . $languages_id . "'");
                }
                $attributes_values = tep_db_fetch_array($attributes);

                $sql_data_array = array('orders_id'               => $insert_id,
                                        'orders_products_id'      => $order_products_id,
                                        'products_options'        => $attributes_values['products_options_name'],
                                        'products_options_values' => $attributes_values['products_options_values_name'],
                                        'options_values_price'    => $attributes_values['options_values_price'],
                                        'price_prefix'            => $attributes_values['price_prefix']);

                tep_db_perform(TABLE_ORDERS_PRODUCTS_ATTRIBUTES, $sql_data_array);

                if ((DOWNLOAD_ENABLED == 'true') && isset($attributes_values['products_attributes_filename']) && tep_not_null($attributes_values['products_attributes_filename'])) {
                  $sql_data_array = array('orders_id'                => $insert_id,
                                          'orders_products_id'       => $order_products_id,
                                          'orders_products_filename' => $attributes_values['products_attributes_filename'],
                                          'download_maxdays'         => $attributes_values['products_attributes_maxdays'],
                                          'download_count'           => $attributes_values['products_attributes_maxcount']);

                  tep_db_perform(TABLE_ORDERS_PRODUCTS_DOWNLOAD, $sql_data_array);
                }
              }
            }
          }

          tep_session_register('cart_MICROPAYMENT_HP_IPN_ID');
          // Terra register globals fix
          $_SESSION['cart_MICROPAYMENT_HP_IPN_ID'] = $cartID . '-' . $insert_id;
        }
      }

      return false;
    }

    function process_button() {
      global $customer_id, $order, $languages_id, $currencies, $currency, $cart_MICROPAYMENT_HP_IPN_ID, $shipping;

      if (MODULE_PAYMENT_MICROPAYMENT_HP_IPN_CURRENCY == 'Selected Currency') {
        $my_currency = $currency;
      } else {
        $my_currency = substr(MODULE_PAYMENT_MICROPAYMENT_HP_IPN_CURRENCY, 5);
      }
      
      if (!in_array($my_currency, array('AUD', 'CAD', 'CHF', 'CZK', 'DKK', 'EUR', 'GBP', 'HKD', 'HUF', 'JPY', 'NOK', 'NZD', 'PLN', 'SEK', 'SGD', 'USD'))) {
        $my_currency = 'USD';
      }
      
      $parameters = array();

      if(MOVE_MICROPAYMENT_HP_TAX_TO_TOTAL_AMOUNT == 'True') {
           $parameters_amount    = number_format($order->info['total'] * $currencies->get_value($my_currency), $currencies->get_decimal_places($my_currency));
           } else {
           // default
          $parameters_amount     = number_format(($order->info['total'] - $order->info['tax']) * $currencies->get_value($my_currency), $currencies->get_decimal_places($my_currency));
      }

	// Zusammenstellen der Micropayment-Parameter
	$m_invoice                = substr($cart_MICROPAYMENT_HP_IPN_ID, strpos($cart_MICROPAYMENT_HP_IPN_ID, '-')+1);

	$parameters['account']    = MODULE_PAYMENT_MICROPAYMENT_HP_IPN_ACCOUNT;
	$parameters['project']    = MODULE_PAYMENT_MICROPAYMENT_HP_IPN_PROJECT;
	$parameters['amount']     = $parameters_amount * 100;
	$parameters['title']      = STORE_NAME . '+-+Bestell-Nr.:+' . $m_invoice . '+/+' . $order->customer['lastname'];
	$parameters['auth']       = '';
	$parameters['country']    = $order->customer['country']['iso_code_2'];
	$parameters['currency']   = $my_currency;
	$parameters['customerid'] = $customer_id;
	$parameters['orderid']    = $m_invoice;
	$parameters['osCsid']     = tep_session_id();

      if (tep_not_null(MODULE_PAYMENT_MICROPAYMENT_HP_IPN_PAGE_STYLE)) {
        $parameters['theme'] = MODULE_PAYMENT_MICROPAYMENT_HP_IPN_PAGE_STYLE;
      }

      if (tep_not_null(MODULE_PAYMENT_MICROPAYMENT_HP_IPN_PAGE_OWNIMG)) {
        $parameters['gfx'] = MODULE_PAYMENT_MICROPAYMENT_HP_IPN_PAGE_OWNIMG;
      }

	$connector = NULL;
	foreach ($parameters as $key => $value) {
		$para .= $connector . $key . '=' . urlencode(stripslashes($value));
		if(empty($connector)) $connector = '&'; 
	}

	if (tep_not_null(MODULE_PAYMENT_MICROPAYMENT_HP_IPN_KEY)) {

		$seal               = md5($para . MODULE_PAYMENT_MICROPAYMENT_HP_IPN_KEY);
		$parameters['seal'] = $seal;
		$para              .= '&seal='.$parameters['seal'];
	}

	$process_button_string = '?'.$para;


      return $process_button_string;
    }

    function before_process() {
      global $cart;

      $cart->reset(true);

	// unregister session variables used during checkout
      tep_session_unregister('sendto');
      tep_session_unregister('billto');
      tep_session_unregister('shipping');
      tep_session_unregister('payment');
      tep_session_unregister('comments');

      tep_session_unregister('cart_MICROPAYMENT_HP_IPN_ID');

      tep_redirect(tep_href_link(FILENAME_CHECKOUT_SUCCESS, '', 'SSL'));

    }

    function after_process() {
      return false;
    }

    function output_error() {
      return false;
    }

    function check() {
      if (!isset($this->_check)) {
        $check_query = tep_db_query("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_MICROPAYMENT_HP_IPN_STATUS'");
        $this->_check = tep_db_num_rows($check_query);
      }
      return $this->_check;
    }

    function install() {

      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Aktiviere Micropayment HP IPN Modul', 'MODULE_PAYMENT_MICROPAYMENT_HP_IPN_STATUS', 'False', 'Zahlungen via Micropayment HP-Event akzeptieren?', '10', '1', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('https-Adresse Ihres Shops', 'MODULE_PAYMENT_MICROPAYMENT_HP_IPN_HTTPS_SHOP', '', 'Bitte geben Sie kein abschliessendes \"\\\" ein.', '10', '2', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Position von HP-Event', 'MODULE_PAYMENT_MICROPAYMENT_HP_IPN_SORT_ORDER', '0', 'Anzeigenreihenfolge, an welcher Stelle dieses Zahlungssystem zur Auswahl fuer den Kunden erscheinen soll. Niedrigste Nummer zuerst.', '10', '3', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('eMail-Adresse', 'MODULE_PAYMENT_MICROPAYMENT_HP_IPN_ID', '', 'Ihre eMail-Adresse fuer den Micropayment HP-Event-Service', '10', '4', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Transaktionswaehrung', 'MODULE_PAYMENT_MICROPAYMENT_HP_IPN_CURRENCY', 'Ausgewaehlte Waehrung', 'Die benutzte Waehrung fuer Transaktionen', '10', '5', 'tep_cfg_select_option(array(\'Selected Currency\',\'Only AUD\',\'Only CAD\',\'Only CHF\',\'Only CZK\',\'Only DKK\',\'Only EUR\',\'Only GBP\',\'Only HKD\',\'Only HUF\',\'Only JPY\',\'Only NOK\',\'Only NZD\',\'Only PLN\',\'Only SEK\',\'Only SGD\',\'Only USD\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('Zahlungszone', 'MODULE_PAYMENT_MICROPAYMENT_HP_IPN_ZONE', '0', 'Ist eine Zone ausgewaehlt, werden nur Zahlungen von Laendern innerhalb dieser Zone akzeptiert.', '10', '6', 'tep_get_zone_class_title', 'tep_cfg_pull_down_zone_classes(', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('Preparing Order Status (Standardwert bevor Transaktion abgeschlossen)', 'MODULE_PAYMENT_MICROPAYMENT_HP_IPN_PREPARE_ORDER_STATUS_ID', '" . $status_id . "', 'Setzte \"prepared orders\" auf:', '10', '7', 'tep_cfg_pull_down_order_statuses(', 'tep_get_order_status_name', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('Acknowledged Order Status (Standardwert bei unklaren Transaktionen)', 'MODULE_PAYMENT_MICROPAYMENT_HP_IPN_ORDER_STATUS_ID', '0', 'Setze \"aknowledged orders\" auf:', '10', '8', 'tep_cfg_pull_down_order_statuses(', 'tep_get_order_status_name', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('Completed Order Status (Standardwert nach erfolgreichem Abschluss der Transaktion)', 'MODULE_PAYMENT_MICROPAYMENT_HP_IPN_COMP_ORDER_STATUS_ID', '0', 'Setze \"completed orders\" auf:', '10', '9', 'tep_cfg_pull_down_order_statuses(', 'tep_get_order_status_name', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Transaktions-Typ', 'MODULE_PAYMENT_MICROPAYMENT_HP_IPN_TRANSACTION_TYPE', 'Event', '', '10', '10', 'tep_cfg_select_option(array(\'Event\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('MwSt auf Endbetrag addieren?', 'MOVE_MICROPAYMENT_HP_TAX_TO_TOTAL_AMOUNT', 'True', 'Wenn Wert=true zeigt Micropayment den Gesamt-Betrag mit MwSt. inkl.', '10', '11', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Seitendesign - Template', 'MODULE_PAYMENT_MICROPAYMENT_HP_IPN_PAGE_STYLE', '', 'Das Seitendesign Ihrer Zahlungsseite (Eingabeformat bsp.: \"l3\" oder leer lassen fuer Standard. Naeheres finden Sie in Ihrem persoenlichen Kontobereich bei Micropayment.)', '10', '12', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Seitendesign - eigenes Logo/Grafik', 'MODULE_PAYMENT_MICROPAYMENT_HP_IPN_PAGE_OWNIMG', '', 'Ihr eigens Logo/Image Ihrer Zahlungsseite (Eingabeformat bsp.: \"x-clouds\" oder leer lassen fuer Standard. Naeheres finden Sie in Ihrem persoenlichen Kontobereich bei Micropayment.)', '10', '13', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Debug E-Mail Address', 'MODULE_PAYMENT_MICROPAYMENT_HP_IPN_DEBUG_EMAIL', '', 'Alle Parameter einer ungueltigen IPN-Informierung werden an diese Adresse gesendet, wenn eine eingetragen ist.', '10', '14', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Project', 'MODULE_PAYMENT_MICROPAYMENT_HP_IPN_PROJECT', '', 'Projekt-Code der von Micropayment vergeben wurde', '10', '15', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Account', 'MODULE_PAYMENT_MICROPAYMENT_HP_IPN_ACCOUNT', '', 'Ihre Accountnummer bei Micropayment', '10', '16', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('AccessKey', 'MODULE_PAYMENT_MICROPAYMENT_HP_IPN_KEY', '', 'Ihr Micropayment Ihr AccessKey', '10', '17', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Mindestsumme um HP nutzen zu koennen', 'MODULE_PAYMENT_MICROPAYMENT_HP_IPN_MIN_TOTAL', '0.49', 'Beispielsweise 2.50 fuer 2.50 Euro (. und kein , fuer Nachkommastellen verwenden)', '10', '18', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Maximalsumme um HP nutzen zu koennen', 'MODULE_PAYMENT_MICROPAYMENT_HP_IPN_MAX_TOTAL', '4.99', 'Beispielsweise 50 fuer 50 Euro (. und kein , fuer Nachkommastellen verwenden)', '10', '19', now())");

    }

    function remove() {
      tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }

   function keys() {
    // PandA.nl move tax to total amount added: ", 'MOVE_MICROPAYMENT_HP_TAX_TO_TOTAL_AMOUNT'"
     return array('MODULE_PAYMENT_MICROPAYMENT_HP_IPN_STATUS', 'MODULE_PAYMENT_MICROPAYMENT_HP_IPN_HTTPS_SHOP', 'MODULE_PAYMENT_MICROPAYMENT_HP_IPN_ID', 'MODULE_PAYMENT_MICROPAYMENT_HP_IPN_SORT_ORDER', 'MODULE_PAYMENT_MICROPAYMENT_HP_IPN_CURRENCY', 'MODULE_PAYMENT_MICROPAYMENT_HP_IPN_ZONE', 'MODULE_PAYMENT_MICROPAYMENT_HP_IPN_PREPARE_ORDER_STATUS_ID', 'MODULE_PAYMENT_MICROPAYMENT_HP_IPN_ORDER_STATUS_ID', 'MODULE_PAYMENT_MICROPAYMENT_HP_IPN_COMP_ORDER_STATUS_ID', 'MODULE_PAYMENT_MICROPAYMENT_HP_IPN_TRANSACTION_TYPE', 'MOVE_MICROPAYMENT_HP_TAX_TO_TOTAL_AMOUNT', 'MODULE_PAYMENT_MICROPAYMENT_HP_IPN_PAGE_STYLE', 'MODULE_PAYMENT_MICROPAYMENT_HP_IPN_PAGE_OWNIMG', 'MODULE_PAYMENT_MICROPAYMENT_HP_IPN_DEBUG_EMAIL', 'MODULE_PAYMENT_MICROPAYMENT_HP_IPN_PROJECT', 'MODULE_PAYMENT_MICROPAYMENT_HP_IPN_ACCOUNT', 'MODULE_PAYMENT_MICROPAYMENT_HP_IPN_KEY', 'MODULE_PAYMENT_MICROPAYMENT_HP_IPN_MIN_TOTAL', 'MODULE_PAYMENT_MICROPAYMENT_HP_IPN_MAX_TOTAL' );
   }
  }
?>